* Make loose item table 	v0.00   1987  J.R.Oakley  QJUMP
*
	section prog
*
	include 'dev8_keys_qdos_sms'
	include 'dev8_keys_err'
	include 'dev8_keys_wwork'
	include 'dev1_asm_qptr_keys'
*
	xref	ut_lfla1
	xref	ut_retfp
*
	xref	bem_chpn
	xref	bem_gdat
	xref	bem_cvia
	xref	bem_gxyw
	xref	bem_gxyb
	xref	bem_gchr
	xref	bem_gobj
	xref	bem_rchp
*
	xdef	be_mklot
*
*	Make a loose item table.
*
be_mklot
	move.l	a5,d5			; keep pointer to end of parameters
	moveq	#6,d7			; we nedd more than 6 parameters
	jsr	bem_chpn(pc)
	sub.l	a5,a5			; flag no heap yet
	bge.s	bem_exbp		; we don't have enough parameters...
*
	addq.l	#8,a3			; second parameter has size
	moveq	#wwl.elen,d6		; space required for an item
	moveq	#wwa.elen+mol.hdrl+2,d0 ; plus space for item attributes
	jsr	bem_gdat(pc)		; get some heap
	bne.s	bem_exit		; ...oops
	move.w	d7,mol_numo(a5) 	; keep number of items in table
	subq.l	#8,a3
*
	jsr	bem_cvia(pc)		; convert the item attributes
	bne.s	bem_exit		; ...oops
*
*	Fill in the table from the arrays passed
*
tbst	equ	mol.hdrl+wwa.elen
*
	moveq	#wwl.elen,d6 
	lea	wwl_xsiz+tbst(a5),a4	; fill in sizes
	addq.l	#8,a3			; from size array
	jsr	bem_gxyw(pc)		; get x/y words
	bne.s	bem_exit		; ...oops
*
	lea	wwl_xorg+tbst(a5),a4	; fill in origins
	addq.l	#8,a3		
	jsr	bem_gxyw(pc)
	bne.s	bem_exit
*
	lea	wwl_xjst+tbst(a5),a4	; fill in justification
	addq.l	#8,a3
	jsr	bem_gxyb(pc)		; compressing two words into a byte
	bne.s	bem_exit
*
	lea	wwl_skey+tbst(a5),a4	; fill in select keys
	addq.l	#8,a3
	jsr	bem_gchr(pc)		; get characters from string
	bne.s	bem_exit
*
	lea	wwl_type+tbst(a5),a4	; fill in type/object/action
	lea	mol_hfre(a5),a5 	; using user heap
	addq.l	#8,a3
	jsr	bem_gobj(pc)
	lea	-mol_hfre(a5),a5	; point back to table start
	bne.s	bem_exit
*
	move.w	#-1,wwl_xsiz-wwl_type(a4) ; mark end of table
	moveq	#0,d0
bem_exit
	tst.l	d0			; OK?
	beq.s	bem_rtad		; yes
*
	move.l	d0,-(sp)
	move.l	a5,d0			; is there any heap?
	beq.s	bem_nrhp		; no
	move.l	d0,a0
	jsr	bem_rchp(pc)		; yes, unlink and return it
bem_nrhp
	move.l	(sp)+,d0
	rts
bem_exbp
	moveq	#err.ipar,d0
	bra.s	bem_exit
*
bem_rtad
	move.l	a5,d1			; set D1 to base of table
	jsr	ut_lfla1(pc)		; and push D1 (floated) onto RI stack
	jmp	ut_retfp(pc)		; and return with 
*
	end
