* Pick a given job to the top
*
*	PICK [#ch,]job_ID | key
*
	section prog
*
	include 'dev8_keys_err'
	include 'dev8_keys_k'
	include 'dev8_keys_qdos_io'
	include 'dev1_asm_qptr_keys'
*
	xref	ut_getch
	xref	ut_lfla1
	xref	ut_retfp
*
	xdef	be_pick
	xdef	be_wake
be_wake
	moveq	#k.wake,d7
be_pick
	moveq	#6,d1			; we want space for one FP number
	move.w	bv.chrix,a2
	jsr	(a2)			; so ensure it's there
*
	jsr	ut_getch(pc)		; get channel ID
	bne.s	bep_exer		; ...oops
	move.w	ca.gtlin,a2		
	jsr	(a2)			; now some parameters
	bne.s	bep_exer		; ...oops
	move.l	0(a6,a1.l),d1		; get a parameter
	subq.w	#1,d3			; one or two?
	bmi.s	bep_exbp		; none? you wally
	beq.s	bep_doit		; one? that's it then
	cmp.w	#1,d3			; must be exactly two
	bne.s	bep_exbp		; ho hum
	addq.l	#4,a1			; always point to last parameter
	swap	d1			; more - two halves of Job ID
	move.w	2(a6,a1.l),d1		; only want the low word
	swap	d1
bep_doit
	addq.l	#4,a1			; remove long int
	move.l	a1,bv_rip(a6)		; save it through trap
	move.l	a4,a0
	move.l	d7,d2
	moveq	#-1,d3
	moveq	#iop.pick,d0
	trap	#3
*
	move.l	d0,d1			; set D1 to error code...
	jsr	ut_lfla1(pc)		; ...and float it onto the RI stack
	jmp	ut_retfp(pc)		; and return with 
*
bep_exbp
	moveq	#err.ipar,d0
bep_exer
	rts
*
	end
