* Set the pointer position
*
*       SPTR [#ch],xorg,yorg[,relkey]
*
*       relkey=0 for absolute, 1 for hit area relative, -1 or omit for 
*       current definition relative
*
        section prog
*
        include 'dev8_keys_err'
        include 'dev1_asm_qptr_keys'
        include 'dev8_keys_qdos_io'
*
        xref    ut_getch
        xdef    be_sptr
be_sptr
        jsr     ut_getch(pc)		; get channel ID
        bne.s   bes_exit		; ...oops
        move.w  ca.gtint,a2
        jsr     (a2)		; get some integers
        bne.s   bes_exit		; ...oops
        moveq   #-1,d2		; assume relative to current definition
        subq.w  #2,d3		; is it?
        bmi.s   bes_exbp		; not enough parameters
        beq.s   bes_doit		; yes, by default
        move.w  4(a6,a1.l),d2 	; set required value
bes_doit
        move.l  0(a6,a1.l),d1 	; get co-ordinates
        moveq   #-1,d3		; sometime
        move.l  a4,a0		; this channel
        moveq   #iop.sptr,d0
        trap    #3
bes_exit
        tst.l   d0
        rts
bes_exbp
        moveq   #err.ipar,d0
        bra.s   bes_exit
*
        end
